﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AntiAircraftGun
{
    internal class DrawingUpdateAntiAircraftGun : DrawingAntiAircraftGun
    {
        /// <summary>
        /// Инициализация свойств
        /// </summary>
        /// <param name="speed">Скорость</param>
        /// <param name="weight">Вес зенитного орудия</param>
        /// <param name="bodyColor">Цвет корпуса</param>
        /// <param name="dopColor">Дополнительный цвет</param>
        /// <param name="gun">Признак наличия башни с орудием</param>
        /// <param name="radar">Признак наличия радара</param>
        public DrawingUpdateAntiAircraftGun(int speed, float weight, Color bodyColor, Color dopColor, bool gun, bool radar) :
        base(speed, weight, bodyColor, 110, 75)
        {
            AntiAircraftGun = new EntityUpdateAntiAircraftGun(speed, weight, bodyColor, dopColor, gun, radar);
        }
        public override void DrawTransport(Graphics g)
        {
            if (AntiAircraftGun is not EntityUpdateAntiAircraftGun updateAntiAircraftGun)
            {
                return;
            }
            Pen dopPen = new(updateAntiAircraftGun.DopColor, 4);
            Brush dopBrush = new SolidBrush(updateAntiAircraftGun.DopColor);
            _startPosY += 35;
            base.DrawTransport(g);
            _startPosY -= 35;
            if (updateAntiAircraftGun.Gun)
            {
                g.FillRectangle(dopBrush, _startPosX + 35, _startPosY + 20, 25, 15);
                g.FillRectangle(dopBrush, _startPosX + 60, _startPosY + 25, 50, 5);
                g.FillRectangle(dopBrush, _startPosX + 60, _startPosY + 30, 20, 5);
            }
            if (updateAntiAircraftGun.Radar)
            {
                g.DrawLine(dopPen, _startPosX + 27, _startPosY + 35, _startPosX + 27, _startPosY + 20);
                g.FillPie(dopBrush, _startPosX + 3, _startPosY, 30, 30, -45, 180);
                g.DrawLine(dopPen, _startPosX + 20, _startPosY + 15, _startPosX + 15, _startPosY + 10);
                g.FillEllipse(dopBrush, _startPosX + 10, _startPosY + 5, 10, 10);
            }
        }
    }
}
